package com.niko.pg;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Graphics.DisplayMode;
import com.badlogic.gdx.Input.Keys;
import com.badlogic.gdx.InputProcessor;

import com.niko.pg.engine.StateBasedGame;
import com.niko.pg.engine.TestWorld2;
import com.niko.pg.engine.WorldRenderer;

/**
 * 
 * @author Niko
 * 
 */
public class Game extends StateBasedGame {

	public WorldRenderer worldRenderer;

	public boolean debugEnabled = true;

	@Override
	public void create() {


		// System.out.println("Supports Display Mode Change: " +
		// Gdx.graphics.supportsDisplayModeChange());
		// DisplayMode[] modes = Gdx.graphics.getDisplayModes();
		// System.out.println("Dsiplay Modes:");
		// for (DisplayMode mode : modes) {
		// System.out.println(mode.toString());
		// }
		DisplayMode desktop = Gdx.graphics.getDesktopDisplayMode();
		// System.out.println("Desktop display Mode:");
		// System.out.println(desktop.toString());
		// Gdx.graphics.setDisplayMode(desktop.width, desktop.height, false);

		worldRenderer = new WorldRenderer(desktop.width, desktop.height);
		setState(new TestWorld2(this));
	}
	
	@Override
	public void render() {
		super.render();
		
		Gdx.graphics.setTitle("Game | FPS - " + Gdx.graphics.getFramesPerSecond());
		
		Gdx.input.setInputProcessor(new InputProcessor() {
			
			@Override
			public boolean touchUp(int x, int y, int pointer, int button) {
				return false;
				
			}
			
			@Override
			public boolean touchMoved(int x, int y) {
				return false;
				
			}
			
			@Override
			public boolean touchDragged(int x, int y, int pointer) {
				return false;
				
			}
			
			@Override
			public boolean touchDown(int x, int y, int pointer, int button) {
				return false;
				
			}
			
			@Override
			public boolean scrolled(int amount) {
				return false;
				
			}
			
			@Override
			public boolean keyUp(int keycode) {
				return false;
				
			}
			
			@Override
			public boolean keyTyped(char character) {
				return false;
				
			}
			
			@Override
			public boolean keyDown(int keycode) {
				if (keycode == Keys.F3)
					debugEnabled = !debugEnabled;
				return false;
			}
		});
		
	}

	@Override
	public void dispose() {
		super.dispose();
		worldRenderer.dispose();
	}

}
