package com.niko.pg.engine;

import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.math.Matrix4;
import com.badlogic.gdx.math.Vector3;

import com.niko.pg.engine.entity.Entity;

public class ParallaxCamera extends OrthographicCamera {
	
	Entity follow;

	Matrix4 parallaxView = new Matrix4();
	Matrix4 parallaxCombined = new Matrix4();
	Vector3 tmp = new Vector3();
	Vector3 tmp2 = new Vector3();

	public ParallaxCamera (float viewportWidth, float viewportHeight) {
		super(viewportWidth, viewportHeight);
	}

	public Matrix4 calculateParallaxMatrix (float parallaxX, float parallaxY) {
		update();
		tmp.set(position).scale(parallaxX, parallaxY, 1);
		parallaxView.setToLookAt(tmp, tmp2.set(tmp).add(direction), up);
		parallaxCombined.set(projection);
		Matrix4.mul(parallaxCombined.val, parallaxView.val);
		return parallaxCombined;
	}
	
	@Override
	public void update() {
		if (follow != null) {
			position.x = follow.getX() + follow.getWidth()/2;
			position.y = follow.getY() + follow.getHeight()/2;
		}
		super.update();	
	}
	
	public Entity getFollow() {
		return follow;
	}

	public void setFollow(Entity follow) {
		this.follow = follow;
	}
	
}
