package com.niko.pg.engine.baseEntities;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer;
import com.badlogic.gdx.graphics.glutils.ShapeRenderer.ShapeType;

import com.niko.pg.engine.entity.Entity;

public class Graphic extends Entity {

	{
		collidable = false;
	}

	public Graphic(String name) {
		super(name);
	}

	public Graphic(String name, float x, float y) {
		super(name, x, y);
	}

	public Graphic(String name, TextureRegion region) {
		super(name, region);
	}
	
	public Graphic(String name, float x, float y, TextureRegion region) {
		super(name, x, y, region);
	}
	
	public Graphic(String name, float x, float y, TextureRegion region, int depth) {
		super(name, x, y, region);
		this.depth = depth;
	}
	
	@Override
	public void debug(ShapeRenderer shapeRenderer) {
		drawBounds(shapeRenderer, new Color(0, 1f, 1f, 0.5f));
		drawCenter(shapeRenderer);
		drawOrigin(shapeRenderer);
	}

}
